
#version 120

//this is needed For bitwise operations
#extension GL_EXT_gpu_shader4 : enable


//internal constants
	const float shadowBias = 0.000045;


//inputs from code
	uniform float ambientLight;
	uniform float useLight;
	
	uniform vec4 lightPos;
	uniform vec4 lightLookat;
	uniform vec4 lightColor;
	
	uniform float shadowRange;
	uniform float shadowFalloff;

	// this is the light shadow map
	uniform sampler2D ShadowMap;


//inputs from vertex shader
	varying vec4 vertexDepth;

	varying vec4 vertexPos;
	varying vec4 vertexRaw;
	varying vec4 vertexNormal;

	varying vec4 lightNormal;

	varying vec4 ShadowCoord;


	varying float isLight;
	varying float isGlass;
	varying float isFauxLight;

	varying float materialShine;


vec3 diffuse;
float alpha;
float shadow;



void main()
{
	diffuse = gl_Color.rgb;
	alpha = gl_Color.a;


	//light emit
		float lightEmit = 0.0;
		if (isLight > 0.0){
			lightEmit = alpha;
			alpha = 1.0;
		}else{
			diffuse *= ambientLight;	
		}

	//extract the emitted light an apply it
		if (lightEmit > 0.0){
			diffuse *= (lightEmit+1.0);
			diffuse += (lightEmit * 0.6);
//			diffuse = mix(diffuse*shadow, diffuse, lightEmit);
//		}else{	
////			diffuse *= shadow * clamp(depth, 0.0, 1.0);
//			shadow = clamp(1.0-shadow, 0.0, 1.0) * (lightPower * 0.5);
//
//			diffuse = mix(diffuse, shadCol * diffuse, shadow);
//			diffuse *= clamp(depth, 0.0, 1.0);
////			diffuse *= shadow;
		}



	//get the matshine and matreflect
		float isFauxLight = 0.0;
		float Shine = int(materialShine * 100.0);
		if (Shine > 99.9){
			isFauxLight = 1.0;
			Shine -= 100.0;
		}	
		float matShine = mod(Shine, 10) * 0.1; //0..1
		float matReflect = int(Shine / 10.0) * 0.1; //0..1
		


	//lighting
		shadow = 1.0;
		if (useLight > 0.5) {
			//first do the shadows facing away from the light
				float lightFacing = dot(vertexNormal, lightNormal);
				float cosTheta = clamp(lightFacing, 0.1, 0.9);

				if(lightFacing < 0.0) shadow = 0.7;
			
				
			vec3 lightColor = vec3(1.0, 1.0, 1.0);
			float lightPower = 1.0;	
			//now the material properties	
				//how much light is shining on the surface
				float NdotL = max(0.0, dot(vertexNormal, lightNormal));
				if (NdotL < 0.0) NdotL = 0.0;
				diffuse *= (0.5+(NdotL * 0.5)) * lightPower * lightColor;
	
			//how much light is reflected of the material 0 = no reflection, 1.0 is lots of reflected light
	//			float NdotL = dot(vertexNormal, lightNormal);
	//			if (NdotL < 1.0) {
					diffuse *= 1.0+(NdotL * matReflect);
	//			}	
	
			//how shiny is the material	0..1
				vec4 materialSpecular = vec4(matReflect, matReflect, matReflect, 1);
				
				float plane = dot(vertexNormal.xyz, lightNormal.xyz) * matReflect;// * (lightFalloff * 0.02);
				if (plane < 0.0){
					plane = 0.0;
				}	
		
				diffuse += plane;
	//		diffuse = vec3(plane, 0.0, 0.0);
	
			//specular lighting
				vec4 specular;
				specular = materialSpecular * pow(max(0.0, dot(vertexNormal.xyz, lightNormal.xyz)), matShine);
				diffuse += specular.xyz;
		}			


	gl_FragColor = vec4(diffuse * shadow, alpha);
}
