
#version 120
//this is needed For bitwise operations
#extension GL_EXT_gpu_shader4 : enable


//inputs from the code
	uniform vec4 cameraPos;
	uniform vec4 lightPosRot;
	uniform vec4 lightPos;
	uniform vec4 lightLookat;
	uniform vec4 lightColor;
	uniform float time;
	uniform float cameraXRot;
	uniform float cameraYRot;
	uniform float TMapWidth;
	uniform float TMapHeight;
	
	

//outputs To fragment shader
	varying vec4 vertexDepth;
//	varying vec4 vertexSmooth;

	varying vec3 rotate;

	varying vec4 vertexPos;
	varying vec4 vertexRaw;
	varying vec4 vertexNormal;

//	varying vec4 objectCenter;

	// Used for shadow lookup
		varying vec4 ShadowCoord;

		varying vec4 vertex2light;
		varying vec4 vertex2camera;

		varying vec4 cameraPosRot;
		
//		varying vec4 lightPosRot;
		varying vec4 lightNormal;
		varying vec4 eyeNormal;

		varying vec4 texCoord;
	
		varying vec3 shineColor;
		

		varying float isLight;
		varying float isGlass;
		varying float isFauxLight;
	
		varying float materialShine;
		varying float materialReflect;

		varying float materialType;
		varying float materialData1;
		varying float materialData2;
		varying float materialData3;
		varying float materialData4;
		varying float materialSmooth;
		varying float materialFade;
		varying float materialInvert;
		varying float materialRaise;
		varying float materialSAlpha;
		varying float materialAlpha;
		varying float materialSSS;
		varying float materialSSScatter;
		varying float materialSSBounce;
		varying float materialBump;

	// used for texture lookup
		varying float width;
		varying float height;

		varying float overlay;
		varying float xpos;
		varying float ypos;
	
		varying float overlay1;
		varying float xpos1;
		varying float ypos1;

		varying float cellWidth;
		varying float cellHeight;

		varying float cellWidth2;
		varying float cellHeight2;

	//used for normal calculation
		varying vec3 v_V;
		varying vec3 v_P;
		
		varying vec4 debugCol;

		varying mat4 matRotate;







void main()
{
  // output the transformed vertex
	//	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
		

	//this is the untransformed vertex (not rotated or moved, etc)
		vertexRaw = gl_Vertex;
//		vertexRaw.x += 0.1;
		
	// Transforming The Vertex
		vertexPos = gl_ModelViewMatrix * vertexRaw;
//		gl_Position = ftransform();

	//get the actual vertx depth
		vertexDepth = gl_ModelViewProjectionMatrix * vertexRaw;
		gl_Position = vertexDepth;
		
	//get the corrected vertex normal
//		vertexNormal = normalize( vec4(gl_Normal.xyz, 1) );

		//this is the corrected eye pos
		cameraPosRot = gl_ModelViewMatrix * cameraPos;
		
		//this is the corrected light pos
		vec4 lightPos = gl_ModelViewProjectionMatrix * lightPos;
		vec4 lightLookat = gl_ModelViewProjectionMatrix * lightLookat;
//		vec4 lightPos = gl_ModelViewMatrix * lightPos;
//		vec4 lightLookat = gl_ModelViewMatrix * lightLookat;
//		vec4 lightPos = lightPos;
//		vec4 lightLookat = lightLookat;
//		lightPosRot = lightPos;
		
		
	//this is the light normal
		lightNormal = lightPos - lightLookat;

		vertex2light = (gl_ModelViewProjectionMatrix * lightPosRot) - vertexDepth;
		vertex2camera = -vertexPos;

	
	//this is the eye normal
//		eyeNormal = gl_ModelViewMatrix * vec4(gl_Normal, 0.0);

	//the shine color comes from the normal as we are calculating that in the fragment
		int col = int(gl_Normal.x);
		shineColor.r =float(col & 255) / 255;
		shineColor.g =float((col/256) & 255) / 255;
		shineColor.b = float(gl_Normal.z)/255;
		
		shineColor *= lightColor.rgb * lightColor.a;

	//normal calculation
		v_P = gl_Position.xyz; // v_P is the world position
		v_V = (gl_ModelViewMatrix * gl_Vertex).xyz;


		materialType = mod(gl_MultiTexCoord6.s, 100);
		materialData1 = mod(gl_MultiTexCoord6.t, 100);
		materialData2 = (gl_MultiTexCoord6.t / 100)-100;
		materialData3 = mod(gl_MultiTexCoord7.s, 100);
		materialData4 = (gl_MultiTexCoord6.q / 100)-100;
		materialFade = ((gl_MultiTexCoord7.s / 100)-100) * 0.01;
		
		materialAlpha = (mod(gl_MultiTexCoord6.q, 100) * 0.001); 
		materialSAlpha = (mod(gl_MultiTexCoord6.q, 100) * 0.02)-1; 

		//strip the invert and rais data
		materialInvert = mod(gl_FogCoord, 100) * 0.01;
		materialRaise = (((gl_FogCoord / 100)-100) * 0.007);

//		materialRaise2 = 0.83-pow(0.7-materialRaise, 0.5);
		
//		materialRaise = cos(materialRaise*3.14);
		materialBump = ((gl_MultiTexCoord6.s / 100)-100) * 0.25;

		rotate = -vec3(gl_MultiTexCoord5.s - cameraXRot, gl_MultiTexCoord5.t + cameraYRot, gl_MultiTexCoord5.q);

		vec4 VN = vec4(-vertexRaw.x, 0.5-vertexRaw.y, -vertexRaw.z, 1);
		vertexNormal = VN;

		float cry = cos(rotate.y);
		float sry = sin(rotate.y);
		vertexNormal.x = VN.x * cry - VN.z * sry;
		vertexNormal.z = VN.x * sry + VN.z * cry;
		VN.z = vertexNormal.z;

		float crx = cos(rotate.x);
		float srx = sin(rotate.x);
		vertexNormal.y = VN.y * crx - VN.z * srx;
		vertexNormal.z = VN.y * srx + VN.z * crx;
		
		vertexNormal.z = -vertexNormal.z;

	//output the texture coords
		gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
		
	//output the cell coords
//		width = (1.0 / TMapWidth);//42.0);
//		height = (1.0 / TMapHeight);//27.0);
		width = (1.0 / TMapWidth);
		height = (1.0 / TMapHeight);
		
		xpos = width * int(mod(gl_MultiTexCoord1.s, 100));
		ypos = height * (int(gl_MultiTexCoord1.s / 100)-100);
		overlay = 1;

		xpos1 = int(mod(gl_MultiTexCoord1.t, 100));
		ypos1 = (int(gl_MultiTexCoord1.t / 100)-100);
		overlay1 = 1;

		cellWidth = int(mod(gl_MultiTexCoord1.q, 100));
		cellHeight = (int(gl_MultiTexCoord1.q / 100)-100);

		cellWidth2 = int(mod(gl_MultiTexCoord7.t, 100));
		cellHeight2 = (int(gl_MultiTexCoord7.t / 100)-100);
		
		if (cellWidth < 1){
			overlay = -1;
			overlay1 = -1;
			cellWidth = 1;
			cellHeight = 1;
		}
			if ((xpos1 > 90)||(ypos1 >90)){
				overlay1 = -1;
			}else{
				xpos1 *= width;
				ypos1 *= height;
			}


		materialSSS = mod(gl_MultiTexCoord4.t, 100) * 0.01;
		materialSSScatter = ((gl_MultiTexCoord4.t / 100)-100) * 0.01;

		materialSSBounce = mod(gl_MultiTexCoord7.q, 100) * 0.01;
		materialSmooth = ((gl_MultiTexCoord7.q / 100)-100) * 0.01;

		materialReflect = mod(gl_MultiTexCoord4.s, 100) * 0.005;
		materialShine = ((gl_MultiTexCoord4.s / 100)-100) * 0.01;
		isLight = gl_MultiTexCoord4.q;

	//raw color
		gl_FrontColor = gl_Color;
}
