#version 120

//this is needed For bitwise operations
#extension GL_EXT_gpu_shader4 : enable


//internal constants


//inputs from code
	// this is the Input texturemap
		uniform sampler2D TextureMap;

	uniform float Distance;


//inputs from vertex shader
	varying vec4 vertexLight;
	varying vec4 vertexDepth;

	varying vec4 vertexPos;
	varying vec4 vertexRaw;


	varying vec4 texCoord;

	varying vec2 ParticleA;
	varying vec2 ParticleB;
	varying float ABMix;




//Global variables

void main(){
	vec2 uv = vec2(texCoord.x / 16, texCoord.y / 4);

	float alpha1 = texture2D(TextureMap, uv.xy + ParticleA.xy).r;
	float alpha2 = texture2D(TextureMap, uv.xy + ParticleB.xy).r;
	float alpha = mix(alpha1, alpha2, ABMix);
	
	if (alpha < 0.005) discard;
	
	
	vec3 diffuse = gl_Color.rgb;
	alpha *= gl_Color.a;
	
	//channel 0 is the RGB
	gl_FragData[0] = vec4(diffuse, alpha);

}